(*========================================================*)
(*                      PopUp.MOD                         *)
(*           (C) 1991 P. Engels & DOS-toolbox             *)
(*--------------------------------------------------------*)
(* Compiler:       Topspeed Modula-2 V. 2.XX              *)
(* Speichermodell: Small                                  *)
(* Linker-Option:  Pack Segment ON                        *)
(*========================================================*)

MODULE PopUp;

(* call (seg_name => null), data (seg_name => null) *)

(* Stack und Heap mglichst klein *)
(*# data (stack_size => 3000,
         heap_size => 8000,
         ss_in_dgroup => on) *)

(*die Option (ss_in_dgroup => off) klammert den Stack aus!*)

FROM Lib    IMPORT Intr, DisableBreakCheck;
FROM Window IMPORT Clear, WinType, WinDef, Open, Close,
                   Color, TitleMode, SetTitle, DoubleFrame,
                   FullScreen;
FROM TSR    IMPORT MakeResident;
IMPORT BiosIO;
FROM SYSTEM IMPORT Registers;
FROM IO     IMPORT WrStr;
FROM Lib    IMPORT FarWordMove,Intr;

  PROCEDURE TSRProc; (* TSR - Prozedur *)
  VAR 
    win   : WinType;
    wd    : WinDef;
    ch    : CHAR;
    r     : Registers;
    Screen: FarADDRESS;
    Dummy : FarADDRESS;
  BEGIN
    Screen := [0B800H : 0]; (* Farbe    *)
(*  Screen := [0B000H : 0]; (* Hercules *) *)
    Dummy := [Seg(FullScreen^.Buffer^) :
              Ofs(FullScreen^.Buffer^)];
    r.AH := 0FH;
    Intr (r, 10H); (* Bildschirmseite *)
    r.AH := 3;
    Intr (r, 10H); (* CursorPosition *)
    FullScreen^.CurrentX := CARDINAL(r.DL) + 1;
    FullScreen^.CurrentY := CARDINAL(r.DH) + 1;
    FarWordMove(Screen, Dummy, 80 * 25);
                (* Bildschirm sichern *)
    WITH wd DO
      X1 := 30;
      X2 := 50;
      Y1 := 10;
      Y2 := 12;
      Hidden   := FALSE;
      CursorOn := TRUE;
      FrameOn  := TRUE;
      FrameDef := DoubleFrame;
      WrapOn   := FALSE;
      Foreground := White;
      Background := Black;
      FrameFore  := White;
      FrameBack  := LightGray
    END;
    win := Open(wd);
    SetTitle(win, ' Press Esc ', RightLowerTitle);
    WrStr(' Nur ein Test ');
    REPEAT
      ch := BiosIO.RdKey();
    UNTIL ch = CHR(27);
    Close(win)
  END TSRProc;

BEGIN
  DisableBreakCheck;
  MakeResident(TSRProc, 6800H) (* ALT-F1 *)
END PopUp.

(*========================================================*)
(*                 Ende von PopUp.MOD                     *)
